/* UnQuill v0.4 - output tables */

#include "unquill.h"

void listcond(ushrt first)
{
ushrt addr=first, subsaddr;

while (zmem(addr))
  {
  fprintf(outfile,"%4x: ",addr);
  opword(zmem(addr++));
  fputc(' ',outfile);
  opword(zmem(addr++));
  fprintf(outfile,"  Conditions:\n");
  subsaddr=zword(addr++);
  while (zmem(subsaddr)!=0xFF)
    {
    fprintf(outfile,"%4x:               ",subsaddr);
    opcond(&subsaddr);
    fputc('\n',outfile);
    }
  fprintf(outfile,"                 Actions:\n");
  subsaddr++;
  while (zmem(subsaddr)!=0xFF)
    {
    fprintf(outfile,"%4x:               ",subsaddr);
    opact(&subsaddr);
    fputc('\n',outfile);
    }
  addr++;
  }
  fputc('\n',outfile);
}

void opcond(ushrt *condad)
{
  uchr id=zmem((*condad)++);
  uchr param1;

  opcact(id, "AT     NOTAT  ATGT   ATLT   PRESENTABSENT WORN   NOTWORN"
             "CARRIEDNOTCARRCHANCE ZERO   NOTZEROEQ     GT     LT     ");

  param1=zmem((*condad)++);
  fprintf(outfile,"%4d ",param1);
  if (id > 12) fprintf(outfile,"%4d ",zmem((*condad)++));

  if (verbose)
      {
      indent=44;
      if (id < 4)   /* Location */
          {
          fprintf (outfile,"            ;");
          oneitem (loctab,param1);
          }
      else if (id < 10) /* Object */
          {
          fprintf (outfile,"            ;");
          oneitem (objtab,param1);
          }
      }
}

void opact(ushrt *actad)
{
static char inited=0;
static char params[40];
static char ptype[40];
char n;
uchr id=zmem((*actad)++);
uchr actpar[2];

if ((!inited) && (islql))
  {
  for(n=0;n<39;n++)
    {
         if (n<17) params[n]=0;
    else if (n<33) params[n]=1;
    else           params[n]=2;

         if (n<21) ptype[n]=NIL;
    else if (n<29) ptype[n]=OBJ;
    else           ptype[n]=NIL;
    };
  params[29]=2;
  params[30]=2;
  ptype[21]=LOC;
  ptype[22]=MSG;
  ptype[29]=SWAP;
  ptype[30]=PLC;
  inited++;
  };
if ((!inited) && (!islql))
  {
  for(n=0;n<39;n++)
    {
         if (n<11) params[n]=0;
    else if (n<23) params[n]=1;
    else           params[n]=2;
         if (n<12) ptype[n]=NIL;
    else if (n<21) ptype[n]=OBJ;
    else           ptype[n]=NIL;
    }
  params[20]=2;
  ptype[12]=LOC;
  ptype[13]=MSG;
  ptype[20]=SWAP;
  inited++;
  }

if (islql) opcact(id,"INVEN  DESC   QUIT   END    DONE   OK     ANYKEY "
                     "SAVE   LOAD   TURNS  SCORE  CLS    DROPALLAUTOG  "
                     "AUTOD  AUTOW  AUTOR  PAUSE  PAPER  INK    BORDER "
                     "GOTO   MESSAGEREMOVE GET    DROP   WEAR   DESTROY"
                     "CREATE SWAP   PLACE  SET    CLEAR  PLUS   MINUS  "
                     "LET    BEEP   ");

else       opcact(id,"INVEN  DESC   QUIT   END    DONE   OK     ANYKEY "
                     "SAVE   LOAD   TURNS  SCORE  PAUSE  GOTO   MESSAGE"
                     "REMOVE GET    DROP   WEAR   DESTROYCREATE SWAP   "
                     "SET    CLEAR  PLUS   MINUS  LET    BEEP   ");

for (n=params[id]; n>0;)
  {
  actpar[n-1]=(zmem((*actad)++));
  fprintf(outfile,"%4d ",actpar[--n]);
  }

  if (verbose)
     {
     indent=44;
     switch(ptype[id])
        {
        case PLC:
          fprintf (outfile,"       ;");
          oneitem (objtab,actpar[1]);
          fprintf (outfile,"\n\n                                ");
        /* Fall through to... */
        case LOC:
          fprintf (outfile,"            ;");
          oneitem (loctab,actpar[0]);
          break;
        case SWAP:
          fprintf (outfile,"       ;");
          oneitem (objtab,actpar[0]);
          fprintf (outfile,"\n\n                                ");
          actpar[0]=actpar[1];
        /* Fall through to... */
        case OBJ:
          fprintf (outfile,"            ;");
          oneitem (objtab,actpar[0]);
          break;
        case MSG:
          fprintf (outfile,"            ;");
          oneitem (msgtab,actpar[0]);
          break;
        default:
          ;
        }
     }
}

void opcact(char n, char *str)
{
fprintf(outfile,"%.7s",str+7*n);
}

void listconn(ushrt first,uchr nrms)
{
uchr item=0;
ushrt n=0,dest;

fprintf(outfile,"\n%4x: Connections from   0:",first);
if (verbose)
  {
  indent=23;
  fprintf(outfile," ;");
  oneitem(loctab,0);
  }
fprintf(outfile,"\n      ");
xpos=0;
n=first;
for(item=0;item<(nrms-1);)
  if (zmem(n)==0xFF)
    {
    fprintf(outfile,"\n%4x: Connections from %3d:",n++,++item);
    if (verbose)
      {
      indent=28;
      fprintf(outfile," ;");
      oneitem(loctab,item);
      }
    fprintf(outfile,"\n      ");
    }
  else
    {
    opword(zmem(n++));
    fprintf(outfile," to %3d",dest=zmem(n++));
    if (verbose)
      {
      fprintf(outfile,"           ;");
      oneitem(loctab,dest);
      }
  fprintf(outfile,"\n      ");
    }
}

void listwords(ushrt first)
{
ushrt n,m;

for (n=first; zmem(n); n=n+5)
  {
  fprintf (outfile,"\n%4x: Word %3d: ",n,zmem(n+4));
  for (m=0; m<4; m++) fputc(0xFF-zmem(m+n),outfile);
  }
fputc('\n',outfile);
}

void listpos(ushrt first,uchr n)
{
	uchr m,loc;

	for (m=0; m<n; m++)
  	{
		loc=zmem(first+m);
		fprintf(outfile,"\n%4x: Object %3d is initially ",(first+m),m);
		switch (loc)
    		{
			case 0xFF:
			fprintf(outfile,"Invalid location. ");
			fprintf(stderr,"Warning: Invalid location in object positions table");
			break;

			case 0xFE:
 			fprintf(outfile,"carried.");
 			break;

			case 0xFD:
			fprintf(outfile,"worn.");
			break;

			case 0xFC:
			fprintf(outfile,"not created.");
			break;

			default:
			fprintf(outfile,"in room %3d.",loc);
		} 
		if (verbose)
		{
			opch32('\n');
			indent=44;
			oneitem(objtab,m);
			if (loc<252)
			{
				opch32('\n');
				oneitem(loctab,loc);
			}
		}
	}
	fputc('\n',outfile);
}


void listmap(ushrt first,uchr n)
{
	uchr m,wrd;

	for (m=0; m<n; m++)
	{
		wrd=zmem(first+m);
		fprintf(outfile,"\n%4x: Object %3d named ",(first+m),m);
		opword(wrd);
		if(verbose)
		{	      
			fputs("    ;",outfile);
			indent=31;
			oneitem(objtab,m);
		}
	}
	fputc('\n',outfile);
}
void opword(ushrt wid)
{
ushrt n,m;

for (n=vocab; zmem(n); n=n+5)
  {
  if (zmem(n+4)==wid)
     {
     for (m=0; m<4; m++)
       {
       fputc(0xFF-zmem(m+n),outfile);
       }
     break;
     }
  }
}
void oneitem(ushrt table, uchr item)
{
    ushrt n;
    uchr  cch=0;

    n=zword(table+2*item);
    xpos=0;

    while (cch != 0x1F)
        {
        cch=(0xFF-(zmem(n++)));
        expch(cch,&n);
        }
}

void listitems(char *itmid, ushrt first, ushrt howmany)
{
    uchr item=0,cch;
    ushrt n;

    indent=0;
    howmany=howmany & 0xFF;
    fprintf(outfile,"\nThere are %d %ss.\n",howmany,itmid);
    fprintf(outfile,"\n%4x: %s 0:\n      ",first,itmid);
    xpos=0;
    n=first;
    for(item=0;item<howmany;)
      {
      cch=(0xFF-(zmem(n++)));
      if (cch==31)  /* End of text */
          {
          if (++item==howmany) fprintf(outfile,"\n");
          else fprintf (outfile,"\n%4x: %s %d:\n      ",n,itmid,item);
          xpos=0;
          }
      else
        expch(cch, &n);
      }
}
void clrscr(void)
{
    char n;

    for (n=0; n<24; n++) opch32('\n');
}
void expdict(uchr cch, ushrt *n)
{
    ushrt d=dict;

    if (islql) /* Early games aren't compressed & have no dictionary */
    {
      cch-=164;
      while (cch)
        if (zmem(d++) > 0x7f) cch--;

      /* d=address of expansion text */

      while (zmem(d) < 0x80)
        expch (zmem(d++) & 0x7F,n);
      expch (zmem(d) & 0x7F,n);
    }
}
void expch(uchr cch, ushrt *n)
{
    ushrt tbsp;

    switch (oopt)
    {
    case 'T':                 /* Plain text */
      if      ((cch > 31) && (cch < 127)) opch32(cch);
      else if (cch>164) expdict(cch, n);
      else if (cch>126) opch32('?');
      else if (cch==6)
        for (opch32(' ');(xpos%16);opch32(' '));
      else if (cch==8)    opch32(8);
      else if (cch==0x0D) opch32('\n');
      else if (cch==0x17)
        {
        tbsp=(255-zmem((*n)++)) & 0x1F;
        ++(*n);
        if (xpos > tbsp) opch32('\n');
          for (;tbsp>0;tbsp--) opch32(' ');
        }
      else if ((cch>0x0F) && (cch<0x16)) (*n)++;
      break;
    default:                  /* ZXML */
      switch (cch)
        {
        case 0x0D:
          fprintf (outfile,"<BR>");
          break;
        case 0x17:
          fprintf (outfile,"<TAB%d>",((255-zmem((*n)++)) & 0x1F));
          ++(*n);
          break;
        case '%':
          fprintf (outfile,"%%25;");
          break;
        case '<':
          fprintf (outfile,"&lt;");
          break;
        case '>':
          fprintf (outfile,"&gt;");
          break;
        case '&':
          fprintf (outfile,"&amp;");
          break;
        case 96:
          fprintf (outfile,"&pound;");
          break;
        case 127:
          fprintf (outfile,"&copy;");
          break;
        case 16:
          fprintf (outfile,"<INK%d>",255-zmem((*n)++));
          break;
        case 17:
          fprintf (outfile,"<PAPER%d>",255-zmem((*n)++));
          break;
        case 18:
          if (zmem((*n)++)==0xFF) fprintf (outfile,"</BLINK>");
                          else fprintf (outfile,"<BLINK>");
          break;
        case 19:
          if (zmem((*n)++)==0xFF) fprintf (outfile,"</BRIGHT>");
                          else fprintf (outfile,"<BRIGHT>");
          break;
        case 20:
          if (zmem((*n)++)==0xFF) fprintf (outfile,"</INVERSE>");
                          else fprintf (outfile,"<INVERSE>");
          break;
        case 21:
          if (zmem((*n)++)==0xFF) fprintf (outfile,"</OVER>");
                          else fprintf (outfile,"<OVER>");
          break;
        case 6:
          fprintf(outfile,"<,>");
          break;
        default:
          if ((cch > 31) && (cch < 127)) fputc(cch,outfile);
          else if (cch > 164) expdict (cch, n);
          else fprintf(outfile,"%%%x;",cch);
        }
    break;
    }
}
void listudgs(ushrt addr)
{
  char n,m,xbpos=0;

  fprintf(outfile,"#define udg_width 168\n#define udg_height 8\n\nstatic char udg_bits[] = {\n ");
  for (m=0;m<8;m++)
    for (n=0;n<21;n++)
      {
      fprintf(outfile,"0x%2.2x",zmem(addr+(8*n)+m));
      if (++xbpos==12)
        {
        if ((n==20) && (m==7)) fprintf(outfile,"};\n");
                          else fprintf(outfile,",\n ");
        xbpos=0;
        }
        else       fprintf(outfile,", ");
      }
}
