
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#if (DOS || CPM)
#include <conio.h>
#define YES_GETCH 1
#endif


typedef unsigned char uchr;     /* for brevity */
typedef unsigned short ushrt;   /* -- ditto -- */

#define NIL  100
#define LOC  101
#define MSG  102
#define OBJ  103
#define SWAP 104
#define PLC  105

#ifndef YES_GETCH
char getch();
#endif

uchr zmem(ushrt);
ushrt zword(ushrt);
void clrscr(void);
void oneitem(ushrt,uchr);
void listitems(char *,ushrt,ushrt);
void listwords(ushrt);
void listcond(ushrt);
void listconn(ushrt,uchr);
void listpos(ushrt,uchr);
void listmap(ushrt,uchr);
void listudgs(ushrt);
void opword(ushrt);
void opcond(ushrt *);
void opact(ushrt *);
void opch32(char);
void opcact(char,char *);
void expch (uchr, ushrt *);
void expdict (uchr, ushrt *);

char present(uchr);
uchr doproc(ushrt,uchr,uchr);
void listat(uchr);
void initgame(ushrt);
void playgame(ushrt);
void sysmess(uchr);
uchr ffeq(uchr,uchr);
uchr condtrue(ushrt);
uchr autobj(uchr);
uchr runact(ushrt,uchr);
uchr cplscmp(ushrt, char *);
uchr matchword(char **);
void usage(char *);
void dec32(ushrt);
char yesno(void);
void savegame(void);
void loadgame(void);

#ifdef MAINMODULE

#ifndef TINY
uchr zxmemory[0xA400];    /* Spectrum memory from 0x5C00 up - no room for it
                             in the TINY version. */
#else                     /* In the TINY version, we read in from the file 
                             as required, with two 1k caches of the common 
                             bits: */
uchr buf1[0x400];         /* This buffer holds database pointers and the
                             expansion dictionary */
uchr buf2[0x400];         /* This one holds the vocabulary table */
ushrt b1base,b2base;      /* Spectrum addresses of buffers */
uchr b1full=0,b2full=0;   /* Do buffers contain data? */
#endif

char oopt='T';            /* Output option */
char xpos=0;              /* Used in msg display */
char islql=0;             /* Which format of data record (earlier or later)? */
ushrt ofarg=0;            /* Output to file or stdout? */
ushrt vocab,dict;	  /* Spectrum address of vocabulary & dictionary */
char verbose=0;           /* Output tables verbosely? */
char nobeep=0;            /* Peace and quiet? */
char running=0;           /* Actually playing the game? */
ushrt loctab;
ushrt objtab;             /* Tables of locations, objects, messages */
ushrt msgtab;
ushrt sysbase;		  /* Base of system messages */
ushrt conntab;            /* Connections table */
ushrt objmap;		  /* Word-to-object map */
char indent;              /* Listing in single or multiple mode? */
char *inname;             /* Input filename */

uchr fileid=0xFF;	  /* Save file identity byte */
uchr ramsave[0x101];	  /* RAM save buffer */
uchr flags[37];           /* The Quill flags, 0-36. */
#define TURNLO flags[31]  /* (31-36 are special */
#define TURNHI flags[32]  /* Meanings of the special flags */
#define VERB flags[33]
#define NOUN flags[34]
#define CURLOC flags[35]  /* flags[36] == 0 */
uchr objpos[255];         /* Positions of objects */
uchr maxcar;		  /* Max no. of portable objects */
uchr maxcar1;		  /* As maxcar - later games can change it on the fly */
uchr numcar;              /* Number of objects currently carried */
uchr nobj;                /* No. of objects */
uchr nsys;		  /* No. of system messages */
uchr alsosee=1;		  /* Message "You can also see" */
uchr estop;		  /* Emergency stop flag */

FILE *infile, *outfile;

#else /* def MAINMODULE */


#ifndef TINY
extern uchr zxmemory[0xA400];
#else
extern uchr buf1[0x400];
extern uchr buf2[0x400];
extern ushrt b1base,b2base;      
extern uchr b1full,b2full; 
#endif

extern char oopt, xpos, islql,verbose,nobeep,running,indent,*inname;
extern ushrt ofarg,vocab,dict,loctab,objtab,msgtab,sysbase,conntab,objmap;

extern uchr fileid,ramsave[0x101],flags[37];
#define TURNLO flags[31] 
#define TURNHI flags[32] 
#define VERB flags[33]
#define NOUN flags[34]
#define CURLOC flags[35]
extern uchr objpos[255],maxcar,maxcar1,numcar,nobj,nsys,alsosee,estop;		  /* Emergency stop flag */

extern FILE *infile, *outfile;

#endif /* def MAINMODULE */

#ifndef SEEK_SET        /* Hi-tech C doesn't include SEEK_???. */
#define SEEK_SET 0
#endif

#if (CPM || __PACIFIC__) /* CP/M & Pacific don't support argv[0] */
#define AV0 "UNQUILL"
#else
#define AV0 argv[0]
#endif

#define AV10 argv[1][0]
#define AV11 argv[1][1]

